ATS: The Advanced Terrestrial Simulator
=======================================

The Advanced Terrestrial Simulator (formerly sometimes known as the Arctic Terrestrial Simulator) is a code for solving ecosystem-based, integrated, distributed hydrology.

Capabilities are largely based on solving various forms of Richards equation coupled to a surface flow equation, along with the needed sources and sinks for ecosystem and climate models.  This can (but need not) include thermal processes (especially ice for frozen soils), evapo-transpiration, albedo-driven surface energy balances, snow, biogeochemistry, plant dynamics, deformation, transport, and much more.


Getting the code
----------------

If you just plan on using ATS and think what you want is likely in a recent release, please prefer to use the most recent [release version available here](https://github.com/amanzi/ats/releases).

If you instead expect to do new development, please use the developer version and clone the [ats repository](http://github.com/amanzi/ats) using:

```
git clone http://github.com/amanzi/ats
```


Installation
------------

Please see the [INSTALL](https://github.com/amanzi/ats/blob/master/INSTALL.md) file included in the top level directory of your ATS download.


License and Copyright
---------------------

Please see the [LICENSE](https://github.com/amanzi/ats/blob/master/LICENSE) and [COPYRIGHT](https://github.com/amanzi/ats/blob/master/COPYRIGHT) files included in the top level directory of your ATS download.